<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: TypeProc.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_type_proc_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">TypeProc.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_type_proc_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">    1</a></span>&#160;std::string <a class="code" href="_type_proc_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a>(bsoncxx::document::view docvw,std::string key)</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;{</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;    <span class="keywordtype">bool</span> success = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;    bsoncxx::document::element el = docvw[key];</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;    std::string result;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;    std::uint32_t   test = el.length();</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    <span class="keywordflow">if</span>(test==0)</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    {</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        success=<span class="keyword">false</span>;          </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    } </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        success = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        bsoncxx::document::view v_doc;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keywordflow">if</span>(tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        {           </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;            result = el.get_utf8().value.to_string();   </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        }</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    }       </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;}</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(bsoncxx::builder::basic::document &amp;TypeNode,QualType Type,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>  &amp;BinOpProp,<span class="keyword">const</span> SourceManager &amp;SourceManager);</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a>(bsoncxx::builder::basic::document&amp; CallingNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> clang::NamedDecl *ND,<span class="keyword">const</span> SourceManager &amp;SourceManager);</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#ac091eda49dccd0b7981e68f3620b888b">   28</a></span>&#160;std::pair&lt;std::string,std::string&gt; <a class="code" href="_type_proc_8h.html#ac091eda49dccd0b7981e68f3620b888b">getTypeOrRecordName</a>(bsoncxx::document::view docvw)</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;{</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    std::pair&lt;std::string,std::string&gt; refStmt;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    std::string index   = <a class="code" href="_type_proc_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a>(docvw,<span class="stringliteral">&quot;name&quot;</span>);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    std::string stmtStr = <a class="code" href="_type_proc_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a>(docvw,<span class="stringliteral">&quot;Kind&quot;</span>);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    refStmt.first = index;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    refStmt.second = stmtStr;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  <span class="keywordflow">return</span> refStmt;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;}</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#a09115c0a4c2ab3ac6343a305b355ba2f">   38</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a09115c0a4c2ab3ac6343a305b355ba2f">AnalysePointerType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::Type *PtrType,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>    &amp;BinOpProp)</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    QualType PointeeType = PtrType-&gt;getPointeeType(); <span class="comment">//The type might be a pointee type which points on the actual type information</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">if</span>(!(PointeeType.isNull()))</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {                                   </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(TypeNode,PointeeType,BinOpProp,SourceManager);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    }</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#a78be8c7da6cc5bc953e10e693a4c3483">   50</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a78be8c7da6cc5bc953e10e693a4c3483">AnalyseTypeDefType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> TypedefType *PtrOnTypeDefType,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">const</span> clang::TypedefNameDecl *PtrTypeDefNameDecl =  PtrOnTypeDefType-&gt;getDecl();        </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        TypeNode.append(kvp(<span class="stringliteral">&quot;name&quot;</span>,PtrTypeDefNameDecl-&gt;getNameAsString())); </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> SubLvlPrp;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        bsoncxx::document::view docvw = TypeNode.view();</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordflow">if</span>(!docvw.empty())</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            std::pair&lt;std::string,std::string&gt; refStmt = <a class="code" href="_type_proc_8h.html#ac091eda49dccd0b7981e68f3620b888b">getTypeOrRecordName</a>(docvw);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <a class="code" href="_type_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a>(TypeNode,SubLvlPrp,BinOpProp,PtrTypeDefNameDecl,SourceManager);          </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        }</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;}</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#ac5e15d1359d00283e2522a7158970fef">   70</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#ac5e15d1359d00283e2522a7158970fef">AnalyseStructureType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::Type *PtrType,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordflow">if</span>(PtrType-&gt;isStructureType())</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            {                               </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;Kind&quot;</span>,<span class="stringliteral">&quot;StructureType&quot;</span>));</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            }</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#a4eed1f0946c5612934477df45ec3c2de">   78</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a4eed1f0946c5612934477df45ec3c2de">AnalyseArrayType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::Type *PtrType,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;{ </div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            <span class="keywordflow">if</span>(PtrType-&gt;isConstantArrayType())</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            {</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="keyword">const</span> clang::ArrayType  *arr = PtrType-&gt;getAsArrayTypeUnsafe();</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            QualType ArrayElementtype = arr-&gt;getElementType();</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(TypeNode,ArrayElementtype,BinOpProp,SourceManager);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <span class="keywordflow">if</span>(PtrType-&gt;isVariableArrayType())</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            {</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;Kind&quot;</span>,<span class="stringliteral">&quot;VariableArray&quot;</span>));</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            }</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            <span class="keywordflow">if</span>(PtrType-&gt;isDependentSizedArrayType())</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            {           </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;Kind&quot;</span>,<span class="stringliteral">&quot;DependentSizeArray&quot;</span>));</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;}</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#ab66ba45c7dd94b7e3d4873c9cd85d281">   99</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#ab66ba45c7dd94b7e3d4873c9cd85d281">AnalyseBuiltInType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::Type *PtrType)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;{</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">if</span>(PtrType-&gt;isBuiltinType())</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            <span class="keyword">const</span> BuiltinType *PtrOnBuiltinType = PtrType-&gt;getAs&lt;BuiltinType&gt;();    </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            std::string name = PtrOnBuiltinType-&gt;getName(PrintingPolicy(LangOptions())).str();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;BltInTypName&quot;</span>,name));</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                        </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        }</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">  112</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">AnalyseType</a>(bsoncxx::builder::basic::document &amp;TypeNode,<span class="keyword">const</span> clang::Type *PtrType,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>  &amp;BinOpProp,<span class="keyword">const</span> SourceManager &amp;SourceManager)</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;{</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="comment">//const clang::Type *PtrType  = Type.getTypePtr(); //Change from type with qualifier to type</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordflow">if</span>(PtrType) <span class="comment">// Change of scope : discuss the type of the declaration</span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        TypeNode.append(kvp(<span class="stringliteral">&quot;TypeClassName&quot;</span>,std::string(PtrType-&gt;getTypeClassName())));</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="comment">//      Discuss pointer types         //</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment"></span>        <span class="keyword">const</span> clang::PointerType *PtrOnPtrType = PtrType-&gt;getAs&lt;clang::PointerType&gt;();</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">if</span>(PtrOnPtrType)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        {          </div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;           <a class="code" href="_type_proc_8h.html#a09115c0a4c2ab3ac6343a305b355ba2f">AnalysePointerType</a>(TypeNode,SourceManager,PtrOnPtrType,BinOpProp);          </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="comment">//      Discuss typedef types         //</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment"></span>        <span class="keyword">const</span> TypedefType *PtrOnTypeDefType = PtrType-&gt;getAs&lt;TypedefType&gt;();</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keywordflow">if</span>(PtrOnTypeDefType)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;           <a class="code" href="_type_proc_8h.html#a78be8c7da6cc5bc953e10e693a4c3483">AnalyseTypeDefType</a>(TypeNode,SourceManager,PtrOnTypeDefType,BinOpProp);</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;           </div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        }</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="comment">//      Discuss structure types       //</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment"></span>        <span class="keyword">const</span> RecordType *PtrRecord = PtrType-&gt;getAs&lt;RecordType&gt;();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordflow">if</span>(PtrRecord)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;           <a class="code" href="_type_proc_8h.html#ac5e15d1359d00283e2522a7158970fef">AnalyseStructureType</a>(TypeNode,SourceManager,PtrType,BinOpProp);         </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        }</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="comment">//      Constant array type       //</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment"></span>        </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keywordflow">if</span>(PtrType-&gt;isArrayType())</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;           <a class="code" href="_type_proc_8h.html#a4eed1f0946c5612934477df45ec3c2de">AnalyseArrayType</a>(TypeNode,SourceManager,PtrType,BinOpProp);         </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        }</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="comment">//      Builtin type              //</span></div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="comment">//                        //</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment"></span>        <span class="keyword">const</span> BuiltinType *BuiltInType = PtrType-&gt;getAs&lt;BuiltinType&gt;();</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordflow">if</span>(BuiltInType)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;          <a class="code" href="_type_proc_8h.html#ab66ba45c7dd94b7e3d4873c9cd85d281">AnalyseBuiltInType</a>(TypeNode,SourceManager,PtrType);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        }</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    }</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;}</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160; </div>
<div class="line"><a name="l00177"></a><span class="lineno"><a class="line" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">  177</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(bsoncxx::builder::basic::document &amp;TypeNode,QualType Type,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>  &amp;BinOpProp,<span class="keyword">const</span> SourceManager &amp;SourceManager)</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;{     </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;  <span class="keywordflow">if</span>(!(Type.isNull()))</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    {</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keyword">const</span> clang::Type *PtrType  = Type.getTypePtr(); <span class="comment">//Change from type with qualifier to type  </span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keywordflow">if</span>(PtrType-&gt;isPointerType())</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        {</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;isPointer&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));   </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        }</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;isPointer&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));  </div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        }</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordflow">if</span>(Type.getQualifiers().hasConst())</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        {</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;isConst&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>)); </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        }</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            TypeNode.append(kvp(<span class="stringliteral">&quot;isConst&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));    </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        TypeNode.append(kvp(<span class="stringliteral">&quot;Process&quot;</span>,BinOpProp.<a class="code" href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">FuncName</a>));</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <a class="code" href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">AnalyseType</a>(TypeNode,PtrType,BinOpProp,SourceManager);  </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    }</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;   <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;}</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="a_type_proc_8h_html_ab66ba45c7dd94b7e3d4873c9cd85d281"><div class="ttname"><a href="_type_proc_8h.html#ab66ba45c7dd94b7e3d4873c9cd85d281">AnalyseBuiltInType</a></div><div class="ttdeci">void AnalyseBuiltInType(bsoncxx::builder::basic::document &amp;TypeNode, const SourceManager &amp;SourceManager, const clang::Type *PtrType)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:99</div></div>
<div class="ttc" id="astruct_sub_level_properties_html"><div class="ttname"><a href="struct_sub_level_properties.html">SubLevelProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:544</div></div>
<div class="ttc" id="a_type_proc_8h_html_a4eed1f0946c5612934477df45ec3c2de"><div class="ttname"><a href="_type_proc_8h.html#a4eed1f0946c5612934477df45ec3c2de">AnalyseArrayType</a></div><div class="ttdeci">void AnalyseArrayType(bsoncxx::builder::basic::document &amp;TypeNode, const SourceManager &amp;SourceManager, const clang::Type *PtrType, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:78</div></div>
<div class="ttc" id="a_type_proc_8h_html_ac091eda49dccd0b7981e68f3620b888b"><div class="ttname"><a href="_type_proc_8h.html#ac091eda49dccd0b7981e68f3620b888b">getTypeOrRecordName</a></div><div class="ttdeci">std::pair&lt; std::string, std::string &gt; getTypeOrRecordName(bsoncxx::document::view docvw)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:28</div></div>
<div class="ttc" id="a_type_proc_8h_html_a78be8c7da6cc5bc953e10e693a4c3483"><div class="ttname"><a href="_type_proc_8h.html#a78be8c7da6cc5bc953e10e693a4c3483">AnalyseTypeDefType</a></div><div class="ttdeci">void AnalyseTypeDefType(bsoncxx::builder::basic::document &amp;TypeNode, const SourceManager &amp;SourceManager, const TypedefType *PtrOnTypeDefType, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:50</div></div>
<div class="ttc" id="a_type_proc_8h_html_ae5080d20d1c8746138bb4d32306f33bb"><div class="ttname"><a href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">AnalyseType</a></div><div class="ttdeci">void AnalyseType(bsoncxx::builder::basic::document &amp;TypeNode, const clang::Type *PtrType, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:112</div></div>
<div class="ttc" id="a_type_proc_8h_html_ac5e15d1359d00283e2522a7158970fef"><div class="ttname"><a href="_type_proc_8h.html#ac5e15d1359d00283e2522a7158970fef">AnalyseStructureType</a></div><div class="ttdeci">void AnalyseStructureType(bsoncxx::builder::basic::document &amp;TypeNode, const SourceManager &amp;SourceManager, const clang::Type *PtrType, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:70</div></div>
<div class="ttc" id="astruct_binary_op_properties_html_ac975bdd8407c509fae99646f4a2dbf04"><div class="ttname"><a href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">BinaryOpProperties::FuncName</a></div><div class="ttdeci">std::string FuncName</div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:593</div></div>
<div class="ttc" id="astruct_binary_op_properties_html"><div class="ttname"><a href="struct_binary_op_properties.html">BinaryOpProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:561</div></div>
<div class="ttc" id="a_type_proc_8h_html_a6475dfc685f8a583f49bd17b563a37fa"><div class="ttname"><a href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a></div><div class="ttdeci">void analyzeTypes(bsoncxx::builder::basic::document &amp;TypeNode, QualType Type, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:177</div></div>
<div class="ttc" id="a_type_proc_8h_html_a09115c0a4c2ab3ac6343a305b355ba2f"><div class="ttname"><a href="_type_proc_8h.html#a09115c0a4c2ab3ac6343a305b355ba2f">AnalysePointerType</a></div><div class="ttdeci">void AnalysePointerType(bsoncxx::builder::basic::document &amp;TypeNode, const SourceManager &amp;SourceManager, const clang::Type *PtrType, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:38</div></div>
<div class="ttc" id="a_type_proc_8h_html_ad4b771fd12a876bc2b0e55d207cc11ae"><div class="ttname"><a href="_type_proc_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a></div><div class="ttdeci">std::string ReadUtf8Element(bsoncxx::document::view docvw, std::string key)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:1</div></div>
<div class="ttc" id="a_type_proc_8h_html_a5f31e47fafc3b56fb55a8fdffa67a360"><div class="ttname"><a href="_type_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a></div><div class="ttdeci">void DeclDisPatcher(bsoncxx::builder::basic::document &amp;CallingNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::NamedDecl *ND, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:11</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="_type_proc_8h.html">TypeProc.h</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
